<template>
  <template-page ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
    :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
    :operation="operation">
    <el-dialog title="" width="500px" custom-class="diy-dialog" append-to-body :modal="true" :visible.sync="formDialog"
      :show-close="true" :close-on-click-modal="false" :modal-append-to-body="false" :before-close="formCancel">
      <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
        <zj-form-module :title="formDialogTitles[formDialogType]" label-width="120px" :showPackUp="false"
          :form-data="formData" :form-items="formItems">
        </zj-form-module>
      </zj-form-container>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="formCancel">取 消</el-button>
        <el-button v-if="this.formDialogType !== 2" size="mini" @click="formConfirm" type="primary">确 定</el-button>
      </div>
    </el-dialog>
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import { chargingStandardList2, getMainList, getMainDetail, saveMain, deleteMain, getTypeList, getBrandList } from "@/api/miniapp";
import { getClassifyList } from '@/api/goods'
import ImageUpload from '@/components/file-upload'
export default {
  components: { TemplatePage, ImageUpload },
  mixins: [import_mixin],
  data() {
    return {
      // 事件组合
      optionsEvensGroup: [
        [
          [
            {
              name: '添加收费标准',
              isRole: true,
              click: this.addData
            }
          ],
        ],
      ],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑", "查看"],
      formDialog: false,
      formData: {
        chargingStandardTypeId: "",
        brandId: "",
        oneCategoryId: "",
        twoCategoryId: "",
        status: true,
        imageUrl: [],
      },
      businessTypeList: [], // 业务类型列表
      brandList: [], // 品牌列表
      mainList: [], // 一级分类列表
      smallList: [], // 二级分类列表
    }
  },
  computed: {
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [{
        md: 24,
        isShow: true,
        name: 'el-select',
        options: this.businessTypeList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '业务类型',
          prop: 'chargingStandardTypeId',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'el-select',
        options: this.brandList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '服务品牌',
          prop: 'brandId',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'el-select',
        options: this.mainList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '一级分类',
          prop: 'oneCategoryId',
          rules: [...required]
        },
        events: {
          change: async val => {
            this.smallList = []
            this.formData.twoCategoryId = ""
            if (val) {
              this.smallList = this.mainList.find(item => {
                return item.value == val;
              })?.data?.children?.map(item => ({
                label: item.name,
                value: item.categoryId,
                data: item
              })) || [];
            }
          }
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'el-select',
        options: this.smallList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '二级分类',
          prop: 'twoCategoryId',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'el-radio',
        options: [{ label: "开启", value: true }, { label: "禁用", value: false }],
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2 },
        formItemAttributes: {
          label: '状态',
          prop: 'status',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'slot-component',
        formItemAttributes: {
          label: '图片',
          prop: 'imageUrl',
          rules: [...required]
        },
        render: (h, { props, onInput }) => {
          var { value } = props
          return (
            <ImageUpload fileList={this.formData.imageUrl} uid="imgSrc_chargingStandard_materials_drawing_images" limit={1} isEdit={this.formDialogType !== 2} />
          )
        }
      },
      ]
    }
  },
  methods: {
    // 列表请求函数
    getList: chargingStandardList2,
    // 列表导出函数
    exportList() { },
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      if (item.jname === 'imageUrl') {
        defaultData.render = (h, { row, index, column }) => {
          return (
            <div style="padding:0 6px;cursor: pointer;">
              {row.imageUrl ? row.imageUrl.split(",").map(url => <el-image src={url} preview-src-list={[url]} style="width:80px;height:auto;" />) : null}
            </div>
          )
        }
      }
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    // 表格操作列
    operation(h, { row, index, column }) {
      return (
        <div class='operation-btns'>
          <el-button type="text" onClick={() => {
            getMainDetail({ id: row.id }).then(res => {
              Object.assign(this.formData, res.data, {
                imageUrl: res.data.imageUrl ? [{ url: res.data.imageUrl }] : [],
              })
              this.formDialogType = 2
              this.openForm()
            })
          }}>查看</el-button>
          <el-button type="text" onClick={() => {
            getMainDetail({ id: row.id }).then(res => {
              Object.assign(this.formData, res.data, {
                imageUrl: res.data.imageUrl ? [{ url: res.data.imageUrl }] : [],
              })
              this.formDialogType = 1
              this.openForm()
            })
          }}>编辑</el-button>
          <el-popconfirm
            title="确定删除吗？"
            onConfirm={() => {
              deleteMain({ id: row.id }).then(res => {
                this.$message({
                  type: 'success',
                  message: `删除成功!`,
                })
                this.$refs.pageRef.refreshList()
              })
            }}
          >
            <el-button type="text" slot="reference">删除</el-button>
          </el-popconfirm>
        </div>
      )
    },
    addData() {
      this.formDialogType = 0
      this.openForm()
    },
    openForm() {
      Promise.all([
        getTypeList(),
        getBrandList(),
        getClassifyList({
          type: 2,
          name: '',
        })
      ]).then(([res1, res2, res3]) => {
        this.businessTypeList = res1.data.map(item => ({
          label: item.name,
          value: item.id,
          data: item
        }));
        this.brandList = res2.data.map(item => ({
          label: item.brandName,
          value: item.id,
          data: item
        }));
        this.mainList = res3.data.map(item => ({
          label: item.name,
          value: item.categoryId,
          data: item
        }));
        if (this.formData.oneCategoryId) {
          this.smallList = this.mainList.find(item => {
            return item.value == this.formData.oneCategoryId;
          })?.data?.children?.map(item => ({
            label: item.name,
            value: item.categoryId,
            data: item
          })) || [];
        }
        this.formDialog = true;
      })
    },
    formCancel() {
      this.$refs.formRef.$refs.inlineForm.clearValidate()
      this.$data.formData = this.$options.data().formData
      this.formDialog = false
    },
    formConfirm() {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          var pam = {
            ...this.formData,
            imageUrl: this.formData.imageUrl.map(item => item.url).join(","),
          };
          saveMain({ ...pam, type: 1 }).then(res => {
            this.$message({
              type: 'success',
              message: this.formDialogTitles[this.formDialogType] + `成功!`,
            })
            this.formCancel()
            this.$refs.pageRef.refreshList()
          })
        }
      })
    },
  }
}
</script>

<style lang="scss" scoped></style>
